/*******************************************************************************
 * Copyright (c) 2000, 2004 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 * D Port:
 *     Thomas Demmer <t_demmer AT web DOT de>
 *******************************************************************************/
module org.eclipse.swt.snippets.Snippet16;
 
/*
 * Display example snippet: create one repeating timer (every 500 ms)
 *
 * For a list of all SWT example snippets see
 * http://www.eclipse.org/swt/snippets/
 */
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import java.lang.all;

version(Tango){
    import tango.io.Stdout;
} else { // Phobos
    import std.stdio;
}

void main (String [] args) {
    Display display = new Display ();
    Shell shell = new Shell (display);
    int time = 500;
    Runnable timer;
    timer = dgRunnable( {
        Point point = display.getCursorLocation ();
        Rectangle rect = shell.getBounds ();
        version(Tango){
            if (rect.contains (point)) {
                Stdout("In\n");
            } else {
                Stdout("Out\n");
            }
            Stdout.flush();
        } else { // Phobos
            if (rect.contains (point)) {
                writeln("In");
            } else {
                writeln("Out");
            }
        }
        display.timerExec (time, timer);
    });
    display.timerExec (time, timer);
    shell.setSize (200, 200);
    shell.open ();
    while (!shell.isDisposed()) {
        if (!display.readAndDispatch ()) display.sleep ();
    }
    display.dispose (); 
}
